__package__    = "mtdb"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/mtdb/"
__cvsversion__ = "$Revision: 1.6 $"
__date__       = "$Date: 2007/09/01 06:28:48 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

class tag :
    def __init__ (self, row):
        self.id = row[0]
        self.tag_raw = row[1]

    def as_string (self) :
        return self.tag_raw
    
    def __str__ (self) :
        return self.as_string()

    def __unicode__ (self) :
        return self.as_string()

class tagstore :

    def __init__ (self, dbconn) :
        self.__dbconn = dbconn

    #
    
    def store (self, tag_raw) :
        sql = "INSERT INTO tagstore (tag_raw) VALUES (?)"

        self.__dbconn.execute(sql, (tag_raw,))
        self.__dbconn.commit()

    #
    
    def retrieve (self, tag_raw, expand=False) :
        sql = "SELECT * FROM tagstore WHERE tag_raw=?"
        cur = self.__dbconn.execute(sql, (unicode(tag_raw),))
        res = cur.fetchone()

        if not expand :
            return res

        if res :
            return tag(res)

    #
    
    def retrieve_by_id (self, id, expand=False) :
        sql = "SELECT * FROM tagstore WHERE id=?"
        cur = self.__dbconn.execute(sql, (id, ))
        res = cur.fetchone()
        
        if not expand :
            return res

        return tag(res)
